using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using Exferia_HotelPuntoVenta.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_HotelPuntoVenta._3_Vistas.Listados
{
    public class ABS_Listado_HPV_Clientes_P_Cliente : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_HPV_Clientes_P_Cliente()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_HPV_Clientes_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null));
            
            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, true, true, false, "", null));

            //nombreComercial
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.nombreComercial), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.nombreComercial), "Nombre comercial", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, false, false, false, "", null));

            //razonSocial
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.razonSocial), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.razonSocial), "Razón social", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));

            //cif
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.cif), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.cif), "CIF", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //telefono1
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.telefono1), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.telefono1), "Teléfono 1", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 120, true, false, false, false, "", null));

            //telefono2
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.telefono2), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.telefono2), "Teléfono 2", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 120, true, false, false, false, "", null));

            //ImpuestoCabecera
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_IMPUESTOCABECERA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Clientes_Listado_Modelo.idImpuestoCabecera), nameof(GEN_ImpuestosCabecera), nameof(GEN_ImpuestosCabecera.id), nameof(GEN_ImpuestosCabecera.codigo), nameof(GEN_ImpuestosCabecera.descripcion), nameof(GEN_ImpuestosCabecera.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.ImpuestoCabecera), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.ImpuestoCabecera), "Tipo de Impuesto", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_IMPUESTOCABECERA));

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_HPV_Clientes_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_HPV_Clientes_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_HPV_Clientes_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_HPV_CLIENTES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_HPV_CLIENTES + "_" + nameof(P_Cliente);
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_HPV_Clientes_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
